/*
 * ----------------------------------------------------------
 *
 * zzzupdate-xmms.c
 *   search filesystem for audio files & enqueue them in xmms
 *   (C) 2003 Fabian "zzznowman" Pietsch
 *
 * ----------------------------------------------------------
 *
 * brief ChangeLog:
 *   2003-05-05 original implementation as shell script
 *   2003-08-06 major changes & enhancements
 *   2003-08-06 reimplementation in C
 */

#include <stdio.h>

/* required for stat() */
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define zperror(str) zperror_verbose(__FILE__, __LINE__, str)


int initdirsc = 1;
char *initdirsv[] = {
	"sto"
};
char **initdirsvp = initdirsv;

void zperror_verbose(const char *file, const int line, const char *str)
{
	char tmp[255];

	if (str)
		snprintf(tmp, sizeof(tmp), "%s(%i): %s", file, line, str);
	else
		snprintf(tmp, sizeof(tmp), "%s(%i)", file, line);
	perror(tmp);
}

int searchdir(const char *dir)
{
	struct stat dir_info;

#ifdef DEBUG
	fprintf(stderr, "searchdir(%s)\n", dir);
#endif
	if (stat(dir, &dir_info) != 0) {
		zperror("can't stat");
		return -1;
	}
	
	if (!S_ISDIR(dir_info.st_mode)) {
		zperror("not a dir");
		return -1;
	}
	
	printf("%s is a dir\n", dir);

	/* TODO: do something ;-) */
	
	return 0;
}

int main(const int argc, char **argv)
{
	int initdir_idx;
	
	if (argc > 1) {
		initdirsvp = &argv[1];
		initdirsc = argc - 1;
	}
	for (initdir_idx = 0; initdir_idx < initdirsc; initdir_idx++) {
		searchdir(initdirsvp[initdir_idx]);
	}
	return 0;
}
